/***************************************************************
* file name			: exti.c

* Description   : ⲿжüжʵ

* Author    		: zc

* Version				: 0.1

* Date					: 2015.9.26

* History       
***************************************************************/

#include "exti.h"

/****************************************************************
* function   	: EXTI_GPIO_Config

* Description : ⲿжϴӦGPIO
                KEY1 PC4  ⲿж4
								KEY2 PB10 ⲿж10
								KEY3 PC13 ⲿж13
								KEY4 PA0  WAKEUP¼

* input			  : 

* output      : 
*****************************************************************/
void EXTI_GPIO_Config(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	  
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOB 
	                       | RCC_APB2Periph_GPIOC | RCC_APB2Periph_AFIO, ENABLE); 
	  
  
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	
	GPIO_InitStructure.GPIO_Pin = EXTI_KEY1_Pin;
	GPIO_Init(EXTI_KEY1_Port, &GPIO_InitStructure); 
  GPIO_EXTILineConfig(EXTI_KEY1_PortSource, EXTI_KEY1_PinSource);		//GPIOΪⲿж˿
	
	GPIO_InitStructure.GPIO_Pin = EXTI_KEY1_Pin;
	GPIO_Init(EXTI_KEY2_Port, &GPIO_InitStructure); 
	GPIO_EXTILineConfig(EXTI_KEY2_PortSource, EXTI_KEY2_PinSource);
	
	GPIO_InitStructure.GPIO_Pin = EXTI_KEY3_Pin;
	GPIO_Init(EXTI_KEY3_Port, &GPIO_InitStructure); 
  GPIO_EXTILineConfig(EXTI_KEY3_PortSource, EXTI_KEY3_PinSource);
	
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPD;
	GPIO_InitStructure.GPIO_Pin = EXTI_KEY4_Pin;
	GPIO_Init(EXTI_KEY4_Port, &GPIO_InitStructure); 
  GPIO_EXTILineConfig(EXTI_KEY4_PortSource, EXTI_KEY4_PinSource);
}

/****************************************************************
* function   	: EXTI_MODE_Config

* Description : ⲿжϴüӦж
                KEY1ΪжϽ_WFEģʽ
                KEY2KEY3ΪͨжϵӦLED
                KEY4Ϊ¼CPU

* input			  : 

* output      : 
*****************************************************************/
void EXTI_MODE_Config(void)
{
	EXTI_InitTypeDef EXTI_InitStructure;
	NVIC_InitTypeDef NVIC_InitStructure;
	
	EXTI_DeInit();
	
	EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;        //ⲿж
  EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling;    //½ش
	EXTI_InitStructure.EXTI_LineCmd = ENABLE;                  //ⲿжʹ
	EXTI_InitStructure.EXTI_Line = EXTI_KEY1_Line;             //ⲿжߺ4
	EXTI_Init(&EXTI_InitStructure);
	
	EXTI_InitStructure.EXTI_Line = EXTI_KEY2_Line;             //ⲿжߺ10
	EXTI_Init(&EXTI_InitStructure);
	
	EXTI_InitStructure.EXTI_Line = EXTI_KEY3_Line;             //ⲿжߺ13
	EXTI_Init(&EXTI_InitStructure);
	
	EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Event;        		 //ⲿ¼
	EXTI_InitStructure.EXTI_Line = EXTI_KEY4_Line;             //ⲿжߺ0
	EXTI_Init(&EXTI_InitStructure);
	//PWR_WakeUpPinCmd(ENABLE);																	 //PA0Ϊʹ
	
	NVIC_SetVectorTable(NVIC_VectTab_FLASH,0x0);     				 	 //λFLASHУƫ0
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
	
	/*мӦжߺ*/
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannel = EXTI_KEY1_IRQn;  				
	NVIC_Init(&NVIC_InitStructure);
	
//	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
//	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
//	NVIC_InitStructure.NVIC_IRQChannel = EXTI0_IRQn;  				
//	NVIC_Init(&NVIC_InitStructure);
	
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2;
	NVIC_InitStructure.NVIC_IRQChannel = EXTI_KEY2_3_IRQn;  		
	NVIC_Init(&NVIC_InitStructure);
}

/****************************************************************
* function   	: EXTI4_IRQHandler

* Description : ⲿж4ںʵLEDԼϵͳ_WFEģʽ

* input			  : 

* output      : 
*****************************************************************/
void EXTI4_IRQHandler(void)        
{
	led_light_up(0);
	EXTI_ClearFlag(EXTI_Line4);      															//жߺ4
	PWR_EnterSTOPMode(PWR_Regulator_LowPower, PWR_STOPEntry_WFE);	//WFE˯ģʽ,¼ܻ
	SystemInit();																									//˳STOPģʽҪʼʱӣΪ˯ʱлڲʱ
	LED1_OFF();
}

/****************************************************************
* function   	: EXTI15_10_IRQHandler

* Description : ⲿж1013жڣͨ״̬ȷ
								жϺ

* input			  : 

* output      : 
*****************************************************************/
void EXTI15_10_IRQHandler(void)   
{
	ITStatus EXTI10_Status;
	ITStatus EXTI13_Status;
  EXTI10_Status = EXTI_GetITStatus(EXTI_Line10);  //ⲿж10״̬
	EXTI13_Status = EXTI_GetITStatus(EXTI_Line13); 
	if(EXTI10_Status == SET)
	{
			led_light_up(1);
  }
	if(EXTI13_Status == SET)
	{
			led_light_up(2);
  }
	
	EXTI_ClearFlag(EXTI_Line10 | EXTI_Line13);      /*ⲿж1013Ĺλ */
}
